//
//  ViewController.m
//  AWShelfTable
//
//  Created by KUDO IKUO on 12/08/07.
//  Copyright (c) 2012年 n/a. All rights reserved.
//

#import "ViewController.h"
#import "AWShelfStageCell.h"
//#import "AWBookView.h"

@class AWBookView;
@interface ViewController ()
{
    CGFloat cellHeight;
}
@end

@implementation ViewController
@synthesize shelfTable, stageCell;

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    UINib* nib = [UINib nibWithNibName:@"AWShelfStageCell" bundle: nil];
    self.stageCell = [ [ nib instantiateWithOwner:self options:nil ] objectAtIndex: 0 ];
    cellHeight = self.stageCell.frame.size.height;
    self.shelfTable.separatorStyle = UITableViewCellSeparatorStyleNone;
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return YES;
    //return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
#warning Incomplete method implementation.
    // Return the number of rows in the section.
    return 5;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    int row = indexPath.row;
    
    AWShelfStageCell *cell = (AWShelfStageCell* ) [ tableView dequeueReusableCellWithIdentifier:@"Cell"];
    if (cell == nil) {
        //[[NSBundle mainBundle] loadNibNamed:@"AWShelfStageCell" owner:self options:nil];
        UINib* nib = [UINib nibWithNibName:@"AWShelfStageCell" bundle: nil];
        cell = [ [ nib instantiateWithOwner:self options:nil ] objectAtIndex: 0 ];
    }
    [ cell initBookViews ];
    
    int bookMax = [cell.bookViews count ];
    for( int i = 0; i < bookMax; i++  ) {
        AWBookView* book = [cell.bookViews objectAtIndex: i ];
        book.title.text = [ NSString stringWithFormat:@"(%d,%d)", i, indexPath.row ];
        book.indexPath = indexPath;
        [book.button addTarget:self action:@selector(buttonAction:) forControlEvents:UIControlEventTouchUpInside ];
    }
    
    return cell;
}

-(void) buttonAction: (id) sender 
{
    UIButton* button = ( UIButton* ) sender;
    NSLog( @"button pushed tag:%d ", button.tag );
}


/*
 // Override to support conditional editing of the table view.
 - (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
 {
 // Return NO if you do not want the specified item to be editable.
 return YES;
 }
 */

/*
 // Override to support editing the table view.
 - (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
 {
 if (editingStyle == UITableViewCellEditingStyleDelete) {
 // Delete the row from the data source
 [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
 }   
 else if (editingStyle == UITableViewCellEditingStyleInsert) {
 // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
 }   
 }
 */

/*
 // Override to support rearranging the table view.
 - (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
 {
 }
 */

/*
 // Override to support conditional rearranging of the table view.
 - (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
 {
 // Return NO if you do not want the item to be re-orderable.
 return YES;
 }
 */

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     */
}



- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath 
{  
    return cellHeight;
    
}

@end
